---
title: VTTCue
slug: Web/API/VTTCue
tags:
  - VTTCue
  - text track
  - vtt
---
<p>{{APIRef("WebVTT")}}<br>
 The <code>VTTCue</code> interface—part of the API for handling WebVTT (text tracks on media presentations)—describes and controls the text track associated with a particular {{HTMLElement("track")}} element.</p>

<h2 id="Constructor">Constructor</h2>

<dl>
 <dt>{{domxref("VTTCue.VTTCue", "VTTCue(<var>startTime</var>, <var>endTime</var>, <var>text</var>)")}}</dt>
 <dd>Returns a newly created <code>VTTCue</code> object that covers the given time range and has the given text.</dd>
 <dt>
 <h3 id="Param">Param</h3>
 </dt>
 <dt><code>startTime</code> </dt>
 <dd>The time, in seconds and fractions of a second, that describes the beginning of the range of the <a href="https://html.spec.whatwg.org/multipage/media.html#media-data" id="text-track-model:media-data">media data</a> to which the cue applies.</dd>
 <dt><code>endTime</code> </dt>
 <dd>The time, in seconds and fractions of a second, that describes the end of the range of the <a href="https://html.spec.whatwg.org/multipage/media.html#media-data" id="text-track-model:media-data-2">media data</a> to which the cue applies.</dd>
 <dt><code>text</code> </dt>
 <dd>The raw text of the cue, and rules for its interpretation.</dd>
</dl>

<h2 id="Properties">Properties</h2>

<p class="properties also_inherits"><em>This interface also inherits properties from {{domxref("TextTrackCue")}}.</em></p>

<dl id="property_definitions">
 <dt>{{domxref("VTTCue.region")}}</dt>
 <dd>A {{domxref("VTTRegion")}} object describing the video's sub-region that the cue will be drawn onto, or <code>null</code> if none is assigned.</dd>
 <dt>{{domxref("VTTCue.vertical")}}</dt>
 <dd>Returns an enum representing the cue writing direction.</dd>
 <dt>{{domxref("VTTCue.snapToLines")}}</dt>
 <dd>Returns true if the {{domxref("VTTCue.line")}} attribute is an integer number of lines or a percentage of the video size.</dd>
 <dt>{{domxref("VTTCue.line")}}</dt>
 <dd>Returns the line positioning of the cue. This can be the string <code>auto</code> or a number whose interpretation depends on the value of {{domxref("VTTCue.snapToLines")}}.</dd>
 <dt>{{domxref("VTTCue.lineAlign")}}</dt>
 <dd>Returns an enum representing the alignment of the {{domxref("VTTCue.line")}}.</dd>
 <dt>{{domxref("VTTCue.position")}}</dt>
 <dd>Returns the indentation of the cue within the line. This can be the string <code>auto</code> or a number representing the percentage of the {{domxref("VTTCue.region")}}, or the video size if {{domxref("VTTCue.region")}} is <code>null</code>.</dd>
 <dt>{{domxref("VTTCue.positionAlign")}}</dt>
 <dd>Returns an enum representing the alignment of the cue. This is used to determine what the {{domxref("VTTCue.position")}} is anchored to. The default is <code>auto</code>.</dd>
 <dt>{{domxref("VTTCue.size")}}</dt>
 <dd>Returns a <code>double</code> representing the size of the cue, as a percentage of the video size.</dd>
 <dt>{{domxref("VTTCue.textAlign")}}</dt>
 <dd>Returns an enum representing the alignment of all the lines of text within the cue box.</dd>
 <dt>{{domxref("VTTCue.text")}}</dt>
 <dd>Returns a {{domxref("DOMString")}} with the contents of the cue.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<dl id="method_definitions">
 <dt>{{domxref("VTTCue.getCueAsHTML", "getCueAsHTML()")}}</dt>
 <dd>Returns the cue text as a {{domxref("DocumentFragment")}}.</dd>
</dl>

<h2 id="Example">Example</h2>

<h3 id="HTML">HTML</h3>

<pre class="brush: html">&lt;video controls src="https://interactive-examples.mdn.mozilla.net/media/examples/flower.webm"&gt;&lt;/video&gt;</pre>

<h3 id="CSS">CSS</h3>

<pre class="brush: css">video {
  width: 320px;
  height: 180px;
}</pre>

<h3 id="JavaScript">JavaScript</h3>

<pre class="brush: js">let video = document.querySelector('video');
video.addEventListener('loadedmetadata', () =&gt; {
  const track = video.addTextTrack("captions", "简体中文Subtitles", "zh_CN");
  track.mode = "showing";

  const cueCn = new VTTCue(0, 2.500, '字幕会在0至2.5秒间显示');
  track.addCue(cueCn);

  const cueEn = new VTTCue(2.6, 4, 'Subtitles will display between 2.6 and 4 seconds');
  track.addCue(cueEn);
});
</pre>

<h3 id="Result">Result</h3>

<p>{{EmbedLiveSample('Example')}}</p>

<blockquote>
<p>Chrome: Please Open in JSFiddle to view the live sample. Embed live sample can not show subtitles in Chrome.</p>
</blockquote>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName("WebVTT")}}</td>
   <td>{{Spec2("WebVTT")}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.VTTCue")}}</p>
